// ==========================================================================
//  Get a Random number
//  ROCKEY6 smart generates REAL random number in the smart card.
//  the max. length is 16 bytes.
//  to get a random number more than 16 bytes, you can consist several random 
//  number together
// ==========================================================================
unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls,Dic32u;

type
    TForm1 = class(TForm)
    Button1: TButton;
    List: TListBox;
    procedure Button1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
end;

var
    Form1: TForm1;

implementation



{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
str, str2:string;
errcode:Integer;    // error code
num:Integer;	    // number of reader
hic:Integer;        // device handle
i:Integer;
cmddata:array[0..256] of Char;

begin
    List.Items.Clear();
 

    num := DIC_Find();
    for i:=0 to num-1 do
    begin
	    hic := DIC_Open(i, nil);
		if hic >= 0 then break;		// Find the first ROCKEY
	end;
    if i = num then exit;

   	DIC_Set(cmddata, RANDOM_SIZE, BY_VALUE, 16, nil);	// length of random number
	errcode := DIC_Command(hic, RANDOM, cmddata);	//get a random number
    List.Items.Add('16 bytes random number');
    str2 := '';
	for i:=0 to 15 do
    begin
        FmtStr(str,'%02x  ', [BYTE(cmddata[i])]);
        str2 := str2 + str;
    end;
    List.Items.Add(str2);

    errcode := DIC_Close(hic);

end;

end.


