// ==========================================================
//  find, open and close ROCKEY
// ==========================================================
import java.io.*;

public class Sample1
{
	public Sample1()
	{
	}
	
	public static void main(String [] args)
	{
		int errcode;				// error code
		int num;				// number of ROCKEY
		int hic=0;				// device handle
		int i;
		char name[]=new char[20];

		JavaRockey Rockey=new JavaRockey();
		num = Rockey.DIC_Find();
		System.out.println("Searching ROCKEY: "+num);
		if (num <= 0)
		{
			System.out.println("No ROCKEY found");
			return;
		}

		System.out.println("Open ROCKEY");
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, name);	// Name of ROCKEY
			System.out.print("Open ROCKEY:");
			System.out.println(name);
			if (hic >= 0) 
				break;		// Find the first ROCKEY
		}
		if (i == num)
		{
			System.out.println("No ROCKEY found");
			return;
		}

		// ...	
		// Operate ROCKEY
		// ...

		System.out.println("Close ROCKEY");
		errcode = Rockey.DIC_Close(hic);
		if (errcode != 0)
		{
			System.out.println("ErrorCode: "+errcode);
			return;
		}
	}
}