// ==========================================================================
// Get managment code
// (1) managment code help developers to manage ROCKEY. Users cannot change it.
//	a) Zone Code, ROCKEY is sold in which area
//	b) Agent Code, sold via which agent
//	c) User1 code, sold to which user
//	d) User1 code, sold to which user
// (2) Use DIC_Get to get the info
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int i, num, hic, errcode;
	char cmddata[256];	
	WORD Zone, Agent, User1, User2;

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num) return;

	errcode = DIC_Command(hic, GET_MANAGER_CODE, cmddata);
	Zone =  (WORD)DIC_Get(cmddata, ZONE, BY_VALUE, NULL);
	Agent = (WORD)DIC_Get(cmddata, AGENT, BY_VALUE, NULL);
	User1 = (WORD)DIC_Get(cmddata, USER1, BY_VALUE, NULL);
	User2 = (WORD)DIC_Get(cmddata, USER2, BY_VALUE, NULL);
	printf("Zone code   %04x\n", Zone);
	printf("Agent code %04x\n", Agent);
	printf("User1  %04x\n", User1);
	printf("User2  %04x\n", User2);

	errcode = DIC_Close(hic);
}
