/* extended floating compuation

first, load extended floating library to dongle

input: 16 bytes i.e. 2 floating numbers
ouput: 96 bytes i.e. 12 floating numbers in dRet array
*/

#include "sys_api.h"
#include "string.h"
void main()
{
unsigned char a[8],b[8];
//returned array
unsigned char xdata uRet[105];
memset(uRet,0,sizeof(uRet));
//get parameters
get_input(a,0,0,8); 
get_input(b,8,0,8);
//floating computation
double_asin(a,uRet);
double_acos(a,uRet+8);
double_atan(a,uRet+16);
double_sinh(a,uRet+24);
double_cosh(a,uRet+32);
double_tanh(a,uRet+40);
double_ceil(a,uRet+48);
double_floor(a,uRet+56);
double_exp(a,uRet+64);
double_log(a,uRet+72);
double_log10(a,uRet+80);
double_mod(b,a,uRet+88);
//double_pow(&b,&a,uRet+96);//result=b^a

//results
set_response(104,uRet);
exit();
}
