/* *************************************************************************************************************
 * example for rockey6smart
 * lib : Rockey6sm_xp.dll
 ***************************************************************************************************************/


/* Command Definition*/
declare @GET_CARD_INFO					int
declare @GET_HARDWARE_INFO				int
declare @GET_MANAGER_CODE				int
declare @GET_CARD_PRIVILEGE				int
declare @GET_REMOTE_INFO				int
declare @SET_REMOTE_INFO				int
declare @CHECK_REMOTE_INFO				int
declare @GET_CURRENT_DIR				int
declare @SET_CURRENT_DIR				int
declare @GET_CURRENT_FILE				int
declare @SET_CURRENT_FILE				int
declare @GET_PARENT_DIR					int
declare @SET_PARENT_DIR					int
declare @LIST_DIR					int
declare @READ_FILE					int
declare @WRITE_FILE					int
declare @FORMAT_CARD					int
declare @CREATE_DIR					int
declare @CREATE_FILE					int
declare @REMOVE_DIR					int
declare @REMOVE_FILE					int
declare @RANDOM						int
declare @RUN						int
declare @CRYPTOTEXT_FILE				int
declare @PLAINTEXT_FILE					int

declare @DESENC						int
declare @DESDEC						int
declare @RSAGENKEY					int
declare @RSAENC						int
declare @RSADEC						int
declare @GETFREESPACE					int
declare @MODULE_GETFILEFLAG				int
declare @MODULE_CRYPTOTEXT_MODFLAG			int
declare @MODULE_PLAINTEXT_MODFLAG			int
declare @MODULE_ENCRYPT_CONTENT				int

declare @SETCOUNTER					int
declare @STEPCOUNTER					int

declare @CHECK_SUPER_PASS				int
declare @SET_SUPER_PASS					int
declare @GET_UPGRADE_REMOTE_PASS			int


set @GET_CARD_INFO			= 0x02000000
set @GET_HARDWARE_INFO			= 0x00FF1C00
set @GET_MANAGER_CODE			= 0x00FF1A00
set @GET_CARD_PRIVILEGE			= 0x00FF2200
set @GET_REMOTE_INFO			= 0x00FF1e00
set @SET_REMOTE_INFO			= 0x00FF1003
set @CHECK_REMOTE_INFO			= 0x01FF1003
set @GET_CURRENT_DIR			= 0x00001800
set @SET_CURRENT_DIR			= 0x0000a400
set @GET_CURRENT_FILE			= 0x00001801
set @SET_CURRENT_FILE			= 0x0100a400
set @GET_PARENT_DIR			= 0x00001802
set @SET_PARENT_DIR			= 0x0000a402
set @LIST_DIR				= 0x0000b200
set @READ_FILE				= 0x0000b000
set @WRITE_FILE				= 0x0000d000
set @FORMAT_CARD			= 0x0000e000
set @CREATE_DIR				= 0x0000e001
set @CREATE_FILE			= 0x0100e001
set @REMOVE_DIR				= 0x0000ee00
set @REMOVE_FILE			= 0x0000ee01
set @RANDOM				= 0x00008400
set @RUN				= 0x03000000
set @CRYPTOTEXT_FILE			= 0x04000000
set @PLAINTEXT_FILE			= 0x05000000

set @DESENC				= 0x00005000
set @DESDEC				= 0x00005100
set @RSAGENKEY				= 0x00003300
set @RSAENC				= 0x00003400
set @RSADEC				= 0x00003500

set @GETFREESPACE			= 0x00003000
set @MODULE_GETFILEFLAG			= 0x00003600
set @MODULE_CRYPTOTEXT_MODFLAG		= 0x00003700
set @MODULE_PLAINTEXT_MODFLAG		= 0x00003800
set @MODULE_ENCRYPT_CONTENT		= 0x00003900

set @SETCOUNTER				= 0x00005700
set @STEPCOUNTER			= 0x00005800

set @CHECK_SUPER_PASS			= 0x00FF1002
set @SET_SUPER_PASS			= 0x00FFF402
set @GET_UPGRADE_REMOTE_PASS		= 0x00FF2000


/* File attribuere*/
declare @FILEATTR_NORMAL		smallint
declare @FILEATTR_EXEC			smallint	/* Executable*/
declare @FILEATTR_DIR			smallint	/* Directory file*/
declare @FILEATTR_UPIGNORE		smallint	/* This program will not be executed if current security level is higher than the executable pragram.*/
declare @FILEATTR_INTERNAL		smallint	/* File used by internal application program only and cannot be operated externally.*/

set @FILEATTR_NORMAL			= 0x00
set @FILEATTR_EXEC			= 0x10	
set @FILEATTR_DIR			= 0x20	
set @FILEATTR_UPIGNORE			= 0x40	
set @FILEATTR_INTERNAL			= 0x80	


/* Several pattern operations are pre-defined for the parameter p1 of DIC_Get and DIC_Set function
 * The highest digit of these pattern operations are set as 1
 */
declare @FILL					int
declare @ATR					int
declare @VOLUME					int
declare @FACTORY_TIME				int
declare @HARD_SERIAL				int
declare @SHIP_TIME				int
declare @COS_VERSION				int
declare @ZONE					int
declare @AGENT					int
declare @USER1					int
declare @USER2					int
declare @DIR_ID					int
declare @DIR_CLASS				int
declare @DIR_ATTRIBUTE				int
declare @DIR_PRIVILEGE				int
declare @FILE_NO				int
declare @DIR_NAME				int
declare @FILE_ID				int
declare @FILE_CLASS				int
declare @FILE_ATTRIBUTE				int
declare @FILE_PRIVILEGE				int
declare @FILE_SIZE				int
declare @FILE_NAME				int
declare @WRITE_DATA				int
declare @READ_DATA				int
declare @RUN_DATA				int
declare @RANDOM_SIZE				int
declare @REMOTE_TAG				int
declare @REMOTE_PASS				int
declare @UPGRADE_HARD_SERIAL			int
declare @UPGRADE_REMOTE_TAG			int
declare @UPGRADE_REMOTE_PASS			int
declare @REMOTEPASS_STATUS			int
declare @SUPERPASS_STATUS			int
declare @SUPERPASS_DATA				int
declare @FILE_DATA				int
declare @RELOAD_FLOATLIBS            		int
declare @RELOAD_RSADESLIBS           		int
declare @ISLOADEDFLOATLIBS           		int
declare @ISLOADEDRSADESLIBS          		int
declare @RELOAD_EXTENDFLOATLIBS      		int
declare @ISLOADEXTENDFLOATLIBS       		int

set @FILL					= 0x80000000
set @ATR					= 0x80010000
set @VOLUME					= 0x80020000
set @FACTORY_TIME				= 0x80030000
set @HARD_SERIAL				= 0x80040000
set @SHIP_TIME					= 0x80050000
set @COS_VERSION				= 0x80060000
set @ZONE					= 0x80070000
set @AGENT					= 0x80080000
set @USER1					= 0x80090000
set @USER2					= 0x800A0000
set @DIR_ID					= 0x800B0000
set @DIR_CLASS					= 0x800C0000
set @DIR_ATTRIBUTE				= 0x800D0000
set @DIR_PRIVILEGE				= 0x800E0000
set @FILE_NO					= 0x800F0000
set @DIR_NAME					= 0x80100000
set @FILE_ID					= 0x80110000
set @FILE_CLASS					= 0x80120000
set @FILE_ATTRIBUTE				= 0x80130000
set @FILE_PRIVILEGE				= 0x80140000
set @FILE_SIZE					= 0x80150000
set @FILE_NAME					= 0x80160000
set @WRITE_DATA					= 0x80170000
set @READ_DATA					= 0x80180000
set @RUN_DATA					= 0x80190000
set @RANDOM_SIZE				= 0x801A0000
set @REMOTE_TAG					= 0x801B0000
set @REMOTE_PASS				= 0x801C0000
set @UPGRADE_HARD_SERIAL			= 0x801D0000
set @UPGRADE_REMOTE_TAG				= 0x801E0000
set @UPGRADE_REMOTE_PASS			= 0x801F0000
set @REMOTEPASS_STATUS				= 0x80200000
set @SUPERPASS_STATUS				= 0x80210000
set @SUPERPASS_DATA				= 0x80220000
set @FILE_DATA					= 0x80230000
set @RELOAD_FLOATLIBS            		= 0x0000e002
set @RELOAD_RSADESLIBS           		= 0x0000e003
set @ISLOADEDFLOATLIBS           		= 0x0000e004
set @ISLOADEDRSADESLIBS          		= 0x0000e005 
set @RELOAD_EXTENDFLOATLIBS      		= 0x0000e006
set @ISLOADEXTENDFLOATLIBS       		= 0x0000e007


/*DICST_Des_Data
 *Used by DIC_Set
 */
declare @DES_KEYFILEID				int
declare @DES_KEYINDEX				int
declare @DES_DATA				int

set @DES_KEYFILEID				= 0x80240000
set @DES_KEYINDEX				= 0x80250000
set @DES_DATA					= 0x80260000


/*DICST_After_EncDec_Data
 *Used by DIC_Get
 */
declare @AFTER_ENCDEC_DATA			int

set @AFTER_ENCDEC_DATA				= 0x80270000

/*DICST_Rsa_Data
 *Used by DIC_Set
 */
declare @RSA_KEYFILEID				int
declare @RSA_DATA				int

set @RSA_KEYFILEID				= 0x80280000
set @RSA_DATA					= 0x80290000

/*DICST_Rsa_GenKey
 *Used by Dic_Set
 */
declare @RSA_PUBKEYID				int
declare @RSA_PUBKEYSIZE				int
declare @RSA_PIVKEYID				int

set @RSA_PUBKEYID				= 0x802A0000
set @RSA_PUBKEYSIZE				= 0x802B0000
set @RSA_PIVKEYID				= 0x802C0000


/* In terms of the parameter p2 of DIC_Get and DIC_Set function
 * The highest 2 digits represent the mode if data is input or returned 
 */
declare @BY_VALUE				int
declare @BY_DOUBLE				int
declare @BY_ARRAY				int
declare @BY_STRING				int

set @BY_VALUE					= 0x00000000
set @BY_DOUBLE					= 0x40000000
set @BY_ARRAY					= 0x80000000
set @BY_STRING					= 0xC0000000



/* program declare */ 
declare @hic 	int

declare @retcode	int

declare @cmd 	int
declare @p1	int
declare @p2	int
declare @p3 	int

declare @buffer varchar(256)
declare @cmddata varchar(256)

declare @FactoryTime	int
declare @HardSerial	int
declare @ShipTime	int
declare @COSVersion	int

declare @i		int

/* */
declare @remotepass	varchar(8) 
declare @RemoteTag	int


/* **************************************************************************************************************
 * Search Rockey6 Smart devices connected to the computer
 * 
 * Description
 * If return value is less than 0, it represents one of the error codes which was explained  below
 * If return value equals 0, it represents there is no Dongle reader connected to the computer
 * If return value is greater than 0, it represents the number of Dongle reader connected to the computer
 *( Note:  as the driver had been installed on the computer, generally, it reports the existence of Dongle reader even without device inserting; 
 * therefore, the further confirmation is a necessary step by means of DIC_Open command.
 **************************************************************************************************************/
print '=========================================Search Rockey6 Smart devices connected to the computer======================================'

exec @retcode = xp_dic_find

if @retcode < 1 /* Found no Rockey6 Smart device*/
	begin
		print 'Found no Rockey6 Smart device'
		return
	end
print 'Found the number of Rockey6 Smart devices: '+cast(@retcode as char)



/* ************************************************************************************************************
 * Open the specific Dongle reader 
 * 
 * Input:
 * hic	is the handle of device
 * It is an enumerating value, within the range of 0, 1, 2, ... and the return value of Dic_Find()  
 * For example, if the return value of Dic_Find() is 3, it implies there are 3 Dongle readers had been found; and then 
 * Dic_Open(0, reader_name) means to open the first Dongle reader of all found
 * Using 1 instead of 0 means to open the second one and by analogy to others like this.
 * If hic is a negative value, Dic_Open will try to open the corresponding Dongle reader directly in virtue of the Dongle reader name in the reader_name
 * 
 * reader_name is the name of Dongle reader
 * It is an input/ouput value, used to input the name of Dongle reader when hic is a negative value
 * If returning a non-NULL value, it represents the name of Dongle reader after successfully open the Dongle reader
 * otherwise, it also means the the name of path file regarding to the virtual devices
 *
 * Return value:
 * If greater than or equal to 0,  it is a successful operation and returns the opened handle of hic
 * If less than 0, it returns the error code that is described below in detail
 *
 * Operation to the first-found Dongle reader is defined in tht following example
 ***************************************************************************************************************/
print '============================================= Open the specific Dongle reader ============================================'

set @hic = 0 /* Open the first Rockey6 Smart device */
set @buffer = ''

exec @retcode = xp_dic_open @hic ,@buffer out
if @retcode>0 /* Error in opening Rockey6 Smart device*/
	begin 
		print 'Error in opening Rockey6 Smart device: '+cast(@retcode as char)
		return
	end
print @buffer + ' Open successfully'

/* **************************************************************************************************************
 * Get Manufacturer and Volume information of Rockey6 Smart device 
 * Note: the process of returned error was removed to make the example clear to understand
 * Description:
 * (1) Two types of infomration are contained in Dongle Info, one is involved in the ATR file and another is the volume of the file system belonging to Dongle
 * (2) ATR is an integrant system file towards each Dongle that is generated automatically during the Dongle formatting, 
 *     In general, we recommend software vendors to write their company relative information into the ATR file, therefore, it will be read out immediately 
 *     after DIC_Open operation, to confirm whether this Rockey6 Smart is of their own.
 *     Be careful that the information can be set into the ATR file only while Dongle formatting, and the maximum length of software vendor information is 15 byte.
 * (3) Similar to the computer, there is a complete file system inside of the Dongle with their corresponding volume information, which can be get promptly after Dongle opening.
 *     The maximum length of the volume is 16 byte.
 * (4) When using DIC_Get,  BY_ARRAY, if taking ATR or VOLUME, is always considered as the return mode regardless of the configuration
 *     and the return value of DIC_Get is the length of ATR information or VOLUME information that stored in the buffer
 * (5) It is prerequisite to invoke DIC_Command and GET_CARD_INFO command before using DIC_Get, which is used to obtain the ATR information and VOLUME information inside the Dongle.
 ***************************************************************************************************************/

print '===================================  Get Software Vendor and Volume information of Rockey6 Smart device   ==================================='

set @cmd = @GET_CARD_INFO
set @cmddata = ''
exec  @retcode= xp_DIC_Command @hic , @cmd , @cmddata out
if  @retcode > 0 /* Error in getting information of Rockey6 Smart device! */
	begin
		print 'Error in getting information of Rockey6 Smart device: '+cast(@retcode as char)
	end

/* Software Vendor Information*/
set @p1 = @ATR
set @p2 = @BY_ARRAY
set @buffer = ''

exec  @retcode= xp_DIC_Get @cmddata , @p1 , @p2 , @buffer out
print ' Software Vendor Information:  ' + left( @buffer , @retcode )


/*VOLUME Information*/

set @p1 = @VOLUME
set @p2 = @BY_ARRAY
set @buffer = ''

exec  @retcode= xp_DIC_Get @cmddata , @p1 , @p2 , @buffer out
print ' VOLUME Information:  ' + @buffer


/* **************************************************************************************************************
 * Get Hardware Information
 * Note: the process of returned error was removed to make the example clear to understand
 * Description:
 * (1) Hardware information mainly focus on four aspects content, all of which were factory-set before dongle delivery and cannot be modified by user.
 *    a) FactoryTime is the time when the dongle was produced by the manufacturer
 *    b) HardSerial  is the hardware serial number unique to each other
 *    c) ShipTime is the time when dongle was delivered to the user, relative to the software developer warranty
 *    d) COSVersion  is the version of internal Dongle Operating System
 * (2) Example below shows a skill of using DIC_Get, the last parameter can be set as NULL if the return mode is BY_VALUE, 
*        by the reason that the returned parameter is obtained from the return value.
****************************************************************************************************************/

print '===============================================  Get Hardware Information  ============================================'

set @cmd = @GET_HARDWARE_INFO
set @cmddata = ''
exec  @retcode= xp_DIC_Command @hic , @cmd , @cmddata out
if  @retcode > 0 /* Error in get Hardware Information! */
	begin
		print 'Error in get Hardware Information: '+cast(@retcode as char)
	end

/*Factory Time*/
select @p1 = @FACTORY_TIME
select @p2 = @BY_VALUE
exec  @FactoryTime = xp_DIC_Get @cmddata , @p1 , @p2 , null
print 'Factory Time: '+ cast (  @FactoryTime  as char )

/*Hardware Serial Number*/
select @p1 = @HARD_SERIAL
select @p2 = @BY_VALUE
exec  @HardSerial = xp_DIC_Get @cmddata , @p1 , @p2 , null
print 'Hardware Serial Number: '+cast( @HardSerial as char )

/*Ship Time*/
select @p1 = @SHIP_TIME
select @p2 = @BY_VALUE
exec  @ShipTime = xp_DIC_Get @cmddata , @p1 , @p2 , null
print 'Ship Time: '+cast(@ShipTime as char)

/*COS Version*/
select @p1 = @COS_VERSION
select @p2 = @BY_VALUE
exec  @COSVersion = xp_DIC_Get @cmddata , @p1 , @p2 , null
print 'COS Version: '+cast(@COSVersion as char)

/* **************************************************************************************************************
 * Get Management Code 
 * (1) Four aspects of content are contained in the management code, all of which were factory-set before dongle delivery and cannot be modified by user.
 *     All management codes are used for the purpose of sales management.
 *     Concerning the dongles of software vendors, they are bought from the distributor with the same settings; that is to say, it is impossible for other users 
 *     to have the dongle with the same management code with you. This part of information, in this way, is the key identifier for software vendor to recognize the dongle of their own. 
 *     The similar-number dongle, generally speaking, is the batch of dongle with the identical management code together.
 *     a) Zone is the area code
 *     b) Agent is the agent code
 *     c) User1 is the user code1
 *     d) User2 is the user code2
 * (2) Example below shows a skill of using DIC_Get, the last parameter can be set as NULL if the return mode is BY_VALUE, 
*        by the reason that the returned parameter is obtained from the return value.
 ***************************************************************************************************************/ 

print '=========================================== Get Management Code =============================================='

set @cmd = @GET_MANAGER_CODE
exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

set @p1 = @ZONE
set @p2 = @BY_VALUE
exec @Zone  = xp_DIC_Get @cmddata  , @p1 ,  @p2 , NULL

set @p1= @AGENT
set @p2 = @BY_VALUE
exec @Agent = xp_DIC_Get @cmddata  , @p1 ,  @p2 , NULL

set @p1= @USER1
set @p2 = @BY_VALUE
exec @User1 = xp_DIC_Get @cmddata  , @p1 ,  @p2 , NULL

set @p1 = @USER2
set @p2 = @BY_VALUE
exec @User2 = xp_DIC_Get @cmddata  , @p1 ,  @p2 , NULL

print 'Area Code:  '	+  cast(@Zone  as char)
print 'Agent Code:  '	+  cast(@Agent as char)
print 'User Code1:  '	+  cast(@User1 as char)
print 'User Code2:  '	+  cast(@User2 as char)

/* **************************************************************************************************************
*  Random Number
* Note: the process of returned error was removed to make the example clear to understand
* Description:
* Random number generation is important for most encryption algorithms; but usually, the number generated through the random function of computer is the pseudo one, 
* being unable to grant the requirement of encryption algorithms.
* With the in-line feature of random number generation,  it is easy to get the real random number by using Rockey6 Smart device.
* First of all, the length of the random number has to be set with DIC_Set ( maximum length is 16 bytes), and then call RANDOM command to get the random number, 
* which is stored in cmddata. 
* If 16 bytes is not enough, you can invoke this function many times to get a longer random number.
****************************************************************************************************************/

print '================================================ Random Number =================================================='

set @p1 = @RANDOM_SIZE
set @p2 = @BY_VALUE
exec xp_DIC_Set @cmddata out , @p1 , @p2 , 16, NULL	/* Set length of the random number*/

set @cmd = @RANDOM
exec @retcode = xp_DIC_Command @hic, @cmd , @cmddata out	/* Get random number*/
print  cast ( @cmddata  as binary( 16 ) )


/* ***************************************************************************************************************
*  Super Password and Privilege Status
*  Note: the process of returned error was removed to make the example clear to understand
*  Description:
*  (1) While buying the Rockey6 Smart, the software vendor will be notified an 8-byte super password, which is obligatory for the development of application 
*        but transparent to the end users. 
*     The dongle is in the status showing that super password is being verified after a successful verification, and software vendor can process following privilege operations
*     a) Create and delete executable files
*     b) Create externally and delete internal files
*     c) Format the whole file system
*     d) Reset the super password and maximum retry times
*     e) With Permission to obtain the remote update password
*  (2) Super password of Demo version is 8-consecutive-FF ( FF FF FF FF FF FF FF FF)
*  (3) GET_CARD_PRIVILEGE command returns the privilege status of the current dongle. 1-byte data will be returned in the buffer of cmddata, each bit of which represents 
*       the current privilege status repectively.
*     Generally we defined a cuple of privilege status listed below
*     DICPR_NOPASS		0	* Password not verified status
*     DICPR_SUPERPASS	4	* Super password verified status
*     DICPR_REMOTEPASS	8	* Remote update password verified status
*  (4) The SUPERPASS_STATUS macro of DIC_Get command is applied to check whether the verification of super password is successful or not.
*        The return value of 1 represents successful verification, and 0 indicates that the operation is failed.
*        Similarily, REMOTEPASS_STATUS macro detects whether the verification of remote update password is successful or not.
*  (5) While setting the new super password, it is necessary to set a maximum retry times in addition to the super password.
*        If faile verification goes beyond this maximum retry times, the super password will be invalid from then on.
*****************************************************************************************************************/
print '============================================= Super Password and Privilege Status ============================================ '

/* Get privilege information of Rockey6 Smart*/
set @cmd = @GET_CARD_PRIVILEGE
exec @retcode = xp_DIC_Command @hic  , @cmd ,  @cmddata out

set @p1 = @SUPERPASS_STATUS
set @p2 = @BY_VALUE
exec @retcode = xp_DIC_Get @cmddata , @p1 , @p2 , NULL
if @retcode >0
	begin
		print 'Super password is verified'
	end
else 
	begin
		print 'Super password is not verified'
	end


/* Super password is an 8-consecutive FF */

set @p1 = @FILL
set @p2 = 8
exec xp_DIC_Set @cmddata out , @p1 , @p2 ,0xff , null  

set @cmd = @CHECK_SUPER_PASS
exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

/*  Get privilege information of Rockey6 Smart */
set @cmd = @GET_CARD_PRIVILEGE ;
exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

set @p1 = @SUPERPASS_STATUS
set @p2 = @BY_VALUE
exec @retcode = xp_DIC_Get @cmddata, @p1, @p2, NULL
if @retcode > 0
	begin
		print 'Super password is verified'
	end
else 
	begin
		print 'Super password is not verified'
	end


/* Set New Super Password */
/* Put new super password (0x31 0x31  0x31 0x31 0x31 0x31 0x31 0x31 ) in the buffer
     The parameter p3 of DIC_Set command represents the maximum retry times(10) */

set @p1 = @FILL
set @p2 = 8
exec xp_DIC_Set @buffer out , @p1 , @p2 ,0x31 , null  

set @p1 =  @SUPERPASS_DATA
set @p2 =  @BY_ARRAY
exec xp_DIC_Set @cmddata out , @p1 , @p2 , 10 , @buffer


set @cmd = @SET_SUPER_PASS
exec @retcode = xp_DIC_Command @hic, @cmd, @cmddata out



	/* Back to the normal user status*/
exec @retcode = xp_DIC_Close @hic
exec @retcode = xp_DIC_Open @hic , NULL

	/* Try the new super password*/
set @p1 = @FILL
set @p2 = 8
exec xp_DIC_Set @cmddata out , @p1 , @p2 ,0x31 , null 

set @cmd = @CHECK_SUPER_PASS
exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out


	/* Get privilege information of Rockey6 Smart*/
set @cmd = @GET_CARD_PRIVILEGE
exec @retcode = xp_DIC_Command @hic , @cmd, @cmddata out

set @p1 = @SUPERPASS_STATUS
set @p2 = @BY_VALUE
exec @retcode = xp_DIC_Get @cmddata , @p1 , @p2 , NULL
if  @retcode > 0 
	begin
		print  'Super password is verified'
	end
else
	begin
		print 'Super password is not verified'
	end
		

	/* Restore to the password as 8-consecutive FF*/
set @p1 = @FILL
set @p2 = 8
exec xp_DIC_Set @buffer out , @p1 , @p2 ,0xFF , null  

set @p1 = @SUPERPASS_DATA
set @p2 = @BY_ARRAY
exec @retcode = xp_DIC_Set @cmddata out , @p1, @p2 , 10 , @buffer

set @cmd = @SET_SUPER_PASS
exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out


/* ***************************************************************************************************************
 *File System
 *
 * Note: the process of returned error was removed to make the example clear to understand
 * Description:
 * Like file system of DOS, there are directories and files in the dongle; on the other side, there is a great deal of difference from between them, 
 * let us review some basic information of file ystem in the first place.
 *
 * (1) Directory/File ID (2 bytes)
 *     Each file inside of the dongle has a 16-bit-long  ID,  which must be uniqe to each other under the same directory, taking as the identifier of both directory and files.
 *     Note:
 *     3F00 is the ID of root directory
 *     2F01 is the ID of ATR file
 *     3FFF is the ID of current directory(no use by us)
 *     0000 is sytsem reserved
 *     Above IDs are not available when you create either fileor directory
 *
 * (2) Directory/File Category(1 byte)
 *     a) Each of files and directories has one byte to desribe its category, thus we called it as FCLA.
 *        In general, files with same FCLA will be considered to be part of the same product.
 *     b) Executable files in the dongle are under control of FCLA, only have the ability to read/write and create the data files with the same FCLA.
 *     c) FCLA of every file occupied a one-byte of Dongle, with the range of from 0x00 to 0xFF.
 *     d) An internal one-byte of the system being used to record the current file category, likewise, it was called as "System Current File Category" (and SYSFCLA in abbreviation)
 *     e) A special case is FF( in hexadecimal) meaning "No Category", file with FF can be accessed by executable files of any category.
 *     f) The switch of SYSFCLA = FCLA occurs when "SYSFCLA" either processing the command of "file selection" or calling the executable files inside of the dongle 
 *     g) SYSFCLA will remain the original category if switching to the "No Category" file.
 *     h) "System Current File Privilege" will be reset to 0(SYSPRI = 0 ) while switch taking place between different categories.
 *     i) SYSFCLA is set to FF (No Category) by default after dongle restoration.
 *     j) The category of system root directory is "No Category".
 *     k) Files with same category inside of dongle constitute a sub-system relatively independent to others; data files of "No Category" is the public data, and executable files
 *         of "No Category" is public processing program.
 *     l) Executable files of "No Category" can only access data files of "No Category".
 *     m) More important usage of FCLA is on the aspect of executable file filter, which will be elaborated later.
 *
 *     Suggest on development:
 *     a) FCLA, generally, is applied in the management of developer, category control is a quite easy way in some fields, such as one software vendor developed several types of product, 
 *         or several software vendors developed one product with a cooperative effort.
 *     b) If only one set of software needs to be protected by the dongle, we suggest to set all FCLA as FF in this manner.
 *     c) It is a good idea to make the same category of all files and sub-directories under one directory, and using "File Privilege" to control the file access.
 *
 * (3) Directory/File Privilege (half a byte)
 *     a) Besides category, each file has a "File Access Privilege" ( FPRI) used to control the access of files with same category. 
 *     b) File Access Privilege(FPRI) is set based on files with the same category, that is to say, FPRI is the lower-level access control comparing to the FCLA. 
 *     c) A half-byte space in IC Dongle used to indicate the file's access privilege , there is 16 privileges in different way ranging from 0 to 15; here,  0 means the lowest level where 15 is the highest level.
 *     d) System has one byte to record the access privilege of current file (SYSFPRI)
 *     e) "System access privilege of current file" (SYSFPRI) must be upgraded by the internal executable files of the dongle, 
 *        SYSFPRI = access privilege set by executable files with the method of system calling, and it is not allowable for executable files to set the access privilege above itself;
 *        i.e. SYSFPRI <= FRPI of executable files
 *     f) Executable files can only process ( read/write/create) the data files with the lower-level access privilege
 *     g) Executable files can clean the "System access privilege of current file" (SYSFPRI = 0) while quitting the program.
 *     i) User may set a file attribute ( FILEATTR_UPIGNORE) pointing to the internal executable files of the dongle,  which will notify the system that the file invocation is useless if SYSFPRI >= FPRI of executable files
 *
 *     Suggest for development:
 *     a) FPRI is the upper-level utility to implement file management, it is quite feasible to set all FPRI as 0 if user do not need such a complex management fucntion like this.
 *     b) Attention that FPRI is different from FCLA, doing privilege after category.
 *
 * (4) Directory/File Attribute (Half a byte)
 *     a) Each File/Directory has an attribute desciption(FATTR), and one bit of which represents one attribute respectively.
 *        NORMAL    	0x00	 * Normal File
 *        EXEC		0x10	 * Executable File
 *        DIR		          0x20	 * Directory but File
 *        UPIGNORE	0x40	 * Ignore to above
 *        INTERNAL	0x80	 * Internal File
 *     b) Executable attribute indicating the internal executable file of the dongle, which must be put under the root directory, in addition, it can be created and deleted
 *          only after successfully super password verification 
 *     c) Directory attribute stands in the place of a directory; if setting this attribute others will be ignored accordingly.
 *     d) Ignore to above attribute, with effect only to the internal executable files of the dongle; if setting as SYSFCLA = FCLA, and SYSFPRI > FPRI, this operation will be ignored.
 *     e) Internal file attribute, representing that this file can only be accessed by the executable files; in particular, with successful super password verification it can be deleted but read or write,
*          on the other side, all external access will be denied without super password verification. 
 * (5) Long File Name
 *     While creating file/directory, there is an optional long file name no more than 16-byte-characters. If setting it, operations to this file can be accessed either by file ID or Long File Name.
 * ==========================================================================
 * Desciption of this program:
 * (1) Format operation can be allowed only after successful super password verification; While formatting, user may reset the volume and vendor-related information, which is the one and only 
 *       period of time for user to do so. 
 * (2) It is necessary to provide following information to create corresponding directory, such as direcotry ID,category, privilege, and long file name etc. 
 * (3) The command of listing directories applied a enumeration method; if error returned at the last step, which indicating that there is no more file or directory under the current directory.
 * (4) Similar to the cd xxxx command of DOS, providing directory ID or long file name is approved to use SET_CURRENT_DIR; if using long file name, it is a must to set ID as 0 in the first place. 
 * (5) All of following information are required to create the long file name, which are file ID, category, privilege, attribute, file size, name for this long file etc; 
 *       however, you can set all of them as 0 if long file name is not provided here.
 * (6) While creating file, the file created will be set as current file automatically, with no need to call SET_CURRENT_FILE
 ****************************************************************************************************************/
print '=========================================  File System  =================================================== '

	/* a. Upgrade to the privilege of super user( the privilege of super user is the prerequisite of format operation*/
 set @p1 = @FILL
 set @p2 = 8
 exec xp_DIC_Set @cmddata out , @p1 , @p2 ,0xFF , null /* Super password is 8-consecutive FF*/ 
 
 set @cmd = @CHECK_SUPER_PASS
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* b. Format the whole file syste, thus cleaning all files accordingly
	   Only when formatting, user may reset the volume and vendor-related information*/
 set @p1 = @VOLUME
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , 'DICSYSTEM'
 
 set @p1 = @ATR
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , 'DIC Co.'
 
 set @cmd = @FORMAT_CARD
 exec xp_DIC_Command @hic , @cmd , @cmddata out

	/* c. Downgrade the super password verified status to the normal user stauts, following operations is processed without super user status*/
 exec @retcode = xp_DIC_Close @hic
 exec @retcode = xp_DIC_Open @hic , NULL

	/* d. Create a directory with the ID of 0x1000, and long file name of "Dir1"*/
 set @p1 = @FILL
 set @p2 = 256
 exec xp_DIC_Set @cmddata out, @p1 , @p2 , 0 , NULL		/* Clean up*/
 
 set @p1 = @DIR_ID
 set @p2 = @BY_VALUE 
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0x1000, NULL	/* Directory ID*/

 set @p1 = @DIR_CLASS
 set @p2 = @BY_VALUE 
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0xff, NULL	/* Direcotry Category */
 
 set @p1 = @DIR_NAME
 set @p2 = @BY_ARRAY 
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0, 'Dir1'	/* Long file name of Directory */
 
 set @cmd = @CREATE_DIR
 exec @retcode = xp_DIC_Command @hic , @cmd  , @cmddata out

	/* e. List directory, listing all files and directories under the current directory */
	/*  Note: if listing root directory, the first one is the root file, and the second one is the ATR file */
 set @i = 0 
 while @i <255
 	begin
		set @p1 = @FILE_NO
		set @p2 = @BY_VALUE
		exec xp_DIC_Set @cmddata out , @p1 , @p2 , @i , NULL	/* Numeration Number*/
		
		set @cmd = @LIST_DIR
		exec @retcode = xp_DIC_Command @hic ,  @cmd , @cmddata out 
		if @retcode <> 0
			begin
			 	break
			end

		set @p1 = @DIR_ID
		set @p2 = @BY_VALUE
		exec @retcode  = xp_DIC_Get @cmddata , @p1 , @p2 , NULL	/* Same way to obtain the file and directory */
		
		set @p1 = @DIR_NAME
		set @p2 = @BY_ARRAY
		exec xp_DIC_Get @cmddata, @p1 , @p2 , @buffer out
		
		print cast( @retcode as char ) + ' ' +  @buffer
		
		set @i = @i + 1
	end

	

	/* f. Enter into the 0x1000 directory just created */
 set @p1 = @DIR_ID
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0x1000 , NULL

 set @cmd = @SET_CURRENT_DIR
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* g. Create the sub-directory with the id of 0x2000 under the current 0x1000 directory */
 set @p1 = @FILL
 set @p2 = 256
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , NULL		/* Clean up */

 set @p1 = @DIR_ID
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0x2000 , NULL	/* Directory ID */

 set @p1 = @DIR_CLASS
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0xff , NULL		/* Directory Category */

 set @p1 = @DIR_NAME
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0, 'Dir2'		/* Long file name of Directory */

 set @cmd = @CREATE_DIR
 exec @retcode = xp_DIC_Command @hic, @cmd , @cmddata out

	/* h. Then, create a file with the id of 0x0033 */
 set @p1 = @FILL
 set @p2 = 256
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0, NULL	/* Clean up */

 set @p1 = @FILE_ID
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0x0033 , NULL	/* File ID */

 set @p1 = @FILE_CLASS
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0xff , NULL 	/* File Category */

 set @p1 = @FILE_ATTRIBUTE
 set @p2 = @BY_VALUE
 set @p3 = @FILEATTR_NORMAL
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , @p3 , NULL		/* File Attribute */

 set @p1 = @FILE_SIZE
 set @p2 = @BY_VALUE
 set @p3 = 20
 exec xp_DIC_Set @cmddata out , @p1  , @p2 , @p3 , NULL		/* File Size */

 set @p1 = @FILE_NAME
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1  , @p2 , 0 , 'File1'	/* Long File Name */

 set @cmd =@CREATE_FILE	
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* i. Write 20-byte information into this file */
	/*  Note: this file will be automatically set as the current file after generation */
 set @p1 = @WRITE_DATA
 set @p2 = 20
 exec xp_DIC_Set @cmddata out , @p1, @p2 , 0 , 'abcdefghijklmnopqrst'

 set @cmd = @WRITE_FILE
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* j. Enter into the 0x2000 direcoty just created(through directory name) */
 set @p1 = @DIR_ID
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1  , @p2 , 0 , NULL	/* Must set directory id as 0, means to select by file name */
 
 set @p1 = @DIR_NAME
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0x2000, 'Dir2'	/* Long file name of directory */
 
 set @cmd = @SET_CURRENT_DIR
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* k. Back to the upper-level directory(0x1000) */
 set @cmd = @SET_PARENT_DIR 
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* l. Select the file with the id of 0x0033 being just created */
 set @p1 = @FILE_ID
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2  , 0x0033, NULL
 
 set @cmd = @SET_CURRENT_FILE
 exec @retcode = xp_DIC_Command @hic , @cmd  , @cmddata out

	/* m. Read this file, showing the file size and contents */
 set @p1 = @READ_DATA
 exec xp_DIC_Set @cmddata out ,  @p1 , 20 , 0 , NULL
 
 set @cmd = @READ_FILE	  
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

 set @p1 = @READ_DATA
 set @p2 = @BY_VALUE

 exec @retcode = xp_DIC_Get @cmddata , @p1 , @p2 , @buffer out
 print left( @buffer , @retcode )
/* **************************************************************************************************************
 *Object: Remote Update
 * Note: the process of returned error was removed to make the example clear to understand
 * Description:
 * (1) Remote update is quite a practical management concept provided by Rockey6 Smart. Based on "one-time-password" encryption scheme, it can be used to 
         implement the remote update in full aspects.
 * (2) Example below is designed to display the function of remote update; if taking in the practical application, parts of the procedure should be done within the
 *      user program, whereas others are completed at the server side of software vendor.
 *     Let us explain the operation flow in detail:
 *      1) "a. Set new basic password for remote update"
 *         This is the one-time initialization step before dongle delivery, software vendor cannot modify the remote update password directly once it has been set already.
 *         The only way to reset the remote update password is to format the dongle after successfully verification from super password.
 *      2) "b. Read out remote update information" & "c. Obtain Hardware ID of current Rockey6 Smart"
 *         Both are dongle relative information collected by softwar while remote update is requested by end user ( incl remote update information and hardware ID of current Rockey6 Smart),
 *         and being sent back to the software vendor by certain means.
 *      3) "d. Upgrade  to the privilege of super user" & "e. Obtain the next one of current remote update password"
 *         While receiving the dongle relative information sent by end user, software vendor achieve the new remote update password and send to the specific user.
 *      4) "f. Downgrade the super password verified status to the normal user status"
 *         As this program will demonstrate with two different identifications, switching between two privilege status is necessary and important.
 *      5) "g. Verification of remote update password" & "h. Check whether the verification of remote update password is successful"
 *         After getting the new remote update password from software vendor, user may input this new one into the dongle for verification.
 *         If successfully verified, the remote update tag  will be set internally of dongle, which can be used to decide corresponding action. 
 *         Inner programs of dongle is allowed to detect this remote update tag, therefore, we recommend to finish part of remote update in virtue of the inner programs.
 * (3) Concerning the remote update tag - RemoteTag, it is not the update password but the update status identifier of current dongle set by the software vendor.
 *        It is suggested to record your software version here, which is convenient for software vendor to make clear the update version of end user is from which to which.
 *        This is a 32-bit number, and its highest bit (0x80000000) is used to show whether the "hardware ID" is used or not.  
 *        If the bit is 1, the update password is related to the "hardware ID" of the dongle; 
 *        if it is 0 it means the update password has nothing to do with the "hardware ID" and only makes reference to the previous update password. 
 *        "One Time Password" simplifies update maintenance of the software manufacturer.
 * (4) Additional description: RemoteTag and RemotePass provided by software vendor are relative to each other, end user is prohibited to modify any one of them.
 *        If the highest digit of RemoteTag is 1, the update password is only valid for specific Rockey6 Smart device. In terms of the dongle-related informaiton provided by end user
 *        to the software vendor, only hardware ID and last update password are necessary, however, last RemoteTag served as reference for remote update making no difference to the next one,
 *        Here, the RemoteTag should be unique to each other provided by software vendor every time processing the remote update. 
 ***************************************************************************************************************/
print '========================================= Remote Update ======================================================='

	/* a. Set new basic password for remote update */
 set @p1 = @REMOTE_TAG
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 , @p2, 1 , NULL	/* Set RemoteTag as 1 */

 set @p1 = @FILL
 set @p2 = 8
 exec xp_DIC_Set @buffer out , @p1 , @p2 ,'A' , null  /* Set the new remote update password as 8-consecutive A */
 	
 
 set @p1 = @REMOTE_PASS
 set @p2 = @BY_ARRAY
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , @buffer 
 set @cmd = @SET_REMOTE_INFO
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out 	/* Update remote update information */

	/* b. Read out remote update information */
 
 set @cmd = @GET_REMOTE_INFO
 exec @retcode = xp_DIC_Command @hic ,  @cmd , @cmddata out
 
 set @p1 = @REMOTE_TAG
 set @p2 = @BY_VALUE	
 exec @RemoteTag = xp_DIC_Get @cmddata ,@p1 , @p2 , NULL
 
 set @p1 = @REMOTE_PASS
 set @p2 = @BY_ARRAY	
 exec xp_DIC_Get @cmddata , @p1  ,  @p2 , @buffer out
 print 'RemoteTag = ' + cast( @RemoteTag as char )
 print 'RemotePass = '
 print  cast ( @buffer  as  binary( 8 ) )
	
 set @remotepass = left( @buffer , 8 )

	/* c. Obtain Hardware ID of current Rockey6 Smart */
 set @cmd = @GET_HARDWARE_INFO
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out	/* Obtain hardware information of Rockey6 Smart device */
 
 set @p1 = @HARD_SERIAL
 set @p2 = @BY_VALUE	
 exec @HardSerial = xp_DIC_Get @cmddata , @p1 , @p2 , NULL


	/* d. Upgrade  to the privilege of super user */
 set @p1 = @FILL
 set @p2 = 8
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0xFF , null /* super password is 8-consecutive FF */

 set @cmd = @CHECK_SUPER_PASS	
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out

	/* e. Obtain the next one of current remote update password */
 set @p1 = @UPGRADE_REMOTE_TAG
 set @p2 = @BY_VALUE	
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 2 , NULL	/* New upgrade remote tag is 2 */

 set @p1 = @UPGRADE_HARD_SERIAL
 set @p2 = @BY_VALUE
 exec xp_DIC_Set @cmddata out , @p1 ,@p2 , @HardSerial , NULL

 set @buffer = left ( @remotepass , 8 )
 set @p1 = @UPGRADE_REMOTE_PASS
 set @p2 = @BY_ARRAY	
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , @buffer
 
 set @cmd = @GET_UPGRADE_REMOTE_PASS
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out
 set  @remotepass = left( @cmddata , 8 )		/* Put the new remote update password into remotepass */

	/* f. Downgrade the super password verified status to the normal user status */
 exec @retcode = xp_DIC_Close @hic
 exec @retcode = xp_DIC_Open @hic , NULL

	/* g. Verification of remote update password */
 set @p1 = @REMOTE_TAG
 set @p2 = @BY_VALUE	
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 2, NULL

 set @buffer = left ( @remotepass , 8 )
 
 set @p1 = @REMOTE_PASS
 set @p2 = @BY_ARRAY	
 exec xp_DIC_Set @cmddata out , @p1 , @p2 , 0 , @buffer
 
 set @cmd = @CHECK_REMOTE_INFO
 exec @retcode = xp_DIC_Command @hic , @cmd  , @cmddata out	/* Verification of remote update information */

	/* h. Check whether the verification of remote update password is successful */
 set @cmd = @GET_CARD_PRIVILEGE
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out 	/* Obtain privilege status information of Rockey6 Smart device */

 
 set @p1 = @REMOTEPASS_STATUS
 set @p2 = @BY_VALUE
 exec @retcode = xp_DIC_Get @cmddata , @p1 , @p2  , NULL
 if ( @retcode > 0 )
 	begin
		print 'Remote update password is verified'
 	end
 else 
	begin
		print 'Remote updatea password is not verified'
 	end


	/* i. Read out the remote update information */
 set @cmd = @GET_REMOTE_INFO
 exec @retcode = xp_DIC_Command @hic , @cmd , @cmddata out
 
 set @p1 = @REMOTE_TAG
 set @p2 = @BY_VALUE	
 exec @RemoteTag = xp_DIC_Get @cmddata , @p1 , @p2 , NULL
 
 set @p1 = @REMOTE_PASS
 set @p2 = @BY_ARRAY
 exec xp_DIC_Get @cmddata , @p1 , @p2 , @buffer out

 print 'RemoteTag = '+  cast( @RemoteTag as char )
 print 'RemotePass = ' 
 print cast (  @buffer as  binary( 8 ) )
	

/* **************************************************************************************************************
 *Close the Rockey6 Smart Device
 ****************************************************************************************************************/
print '========================================= Close the Rockey6 Smart Device ==================================================='
exec @retcode=xp_dic_close @hic
if @retcode>0 /*Error in closing the dongle!*/
	begin 
		print 'Close Rockey Error: '+cast(@retcode as char)
		return
	end
print 'Close the dongle successfully!'
