// ==========================================================================
// Get free space in byte
// ==========================================================================

#include "Rockey.h"
#include "stdio.h"
#include "iostream.h"
#include "dic32.h"

#define DIC_Command  ry.Command
#define DIC_Find     ry.Find
#define DIC_Open     ry.Open
#define DIC_Set      ry.Set
#define DIC_Get      ry.Get
#define DIC_Close    ry.Close


void main(int argc, char* argv[])
{
   CROCKEY ry;
   
	int i,num, hic, errcode;
	
	printf("Searching ROCKEY6 Smart ");
	num = DIC_Find();
	if (num <= 0)
	{
		printf("ROCKEY6 Smart not found\n");
		return;
	}
	printf("%d\n",num);

	printf("Open ROCKEY6 Smart\n");
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);	// no specific reader name, NULL
		if (hic >= 0) break;		// find the first dongle
	}
	if (i == num)
	{
		printf("ROCKEY6 Smart not found\n");
		return;
	}
	
	//get free space
	DWORD dwFreeSpace = 0;
	errcode = DIC_Command(hic, GETFREESPACE, &dwFreeSpace);
	printf("The free space is %d bytes,%d K.\n", dwFreeSpace,dwFreeSpace/1024);
		
	DIC_Close(hic);

    char a;
    cin>>a;

}
//---------------------------------------------------------------------------
 