// ==========================================================================
// Demo: Write and run exe-file.
// Caution: no error check for the sake of briefness and understandability
// Tips:
// (1) You can write exe-files to dongle and run it in dongle. We have Integrate
//     Design Entironment(IDE), you can write,debug,and run program there.
// (2) dist.c is dongle programwe convert the compile result to bin file, and
//     put it to PC program via array.
// (3) You must write exe-file to root directory after super password verification.
// (4) Demo inclue 2 steps: write and run exe-file. The first step should finished befor
//     dongle vending. Then only second step is in final product.
// ==========================================================================
// dist.c caculate a^2+b^2
//
//void main()
//{
//	unsigned int a,b,c;
//	get_input(&a,0,1,1);
//	get_input(&b,2,1,1);
//	a=a*a;
//	b=b*b;
//	c=a+b;
//	set_response(2,&c);
//	exit();
//}
// ==========================================================================
unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls ,Dic32u;

type
    TForm1 = class(TForm)
    Button1: TButton;
    List: TListBox;
    procedure Button1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
end;

var
    Form1: TForm1;

implementation


{$R *.dfm}
procedure ChangeByteOrder(pL:pointer; len:integer);
var
   tmp:byte;
   p1,p2:pbyte;
   i,j:byte;
begin
   p1:=pbyte(pL);
   Inc(p2,len-1);
   p2:=pbyte(pL);
   Inc(p2,len-1);
   
   j:= (len div 2)-1;
   for i:=0 to j do
   begin
      
      tmp:=p1^;
      p1^:=p2^;
      p2^:=tmp;
      Inc(p1,1);
      Inc(p2,-1);
   end
end;

procedure TForm1.Button1Click(Sender: TObject);
var
str:string;
errcode:Integer;    // error code
num:Integer;	    // number of reader
hic:Integer;        // device handle
i:Integer;
cmddata:array[0..256] of Char;
buffer :array[0..256] of Char;
a, b, c : integer;

const
DIST_SIZE = 193;
g_progDIST:array[0..DIST_SIZE-1] of BYTE=
(
$02,$00,$B1,$75,$0E,$00,$75,$0F,$00,$75,$10,$08,$E4,$F5,$11,$75,
$12,$01,$75,$13,$01,$12,$00,$69,$75,$0E,$00,$75,$0F,$00,$75,$10,
$0A,$75,$11,$02,$75,$12,$01,$75,$13,$01,$12,$00,$69,$AE,$08,$AF,
$09,$AC,$08,$AD,$09,$12,$00,$9F,$8E,$08,$8F,$09,$AE,$0A,$AF,$0B,
$AC,$0A,$AD,$0B,$12,$00,$9F,$8E,$0A,$8F,$0B,$E5,$09,$25,$0B,$F5,
$0D,$E5,$08,$35,$0A,$F5,$0C,$75,$0E,$02,$75,$0F,$00,$75,$10,$00,
$75,$11,$0C,$12,$00,$88,$02,$00,$BD,$12,$FF,$00,$E5,$0E,$24,$00,
$E5,$0F,$24,$01,$E5,$10,$24,$02,$E5,$11,$24,$03,$E5,$12,$24,$04,
$E5,$13,$24,$05,$12,$FF,$0B,$22,$12,$FF,$00,$E5,$0F,$24,$00,$E5,
$10,$24,$01,$E5,$11,$24,$02,$E5,$0E,$24,$03,$12,$FF,$0A,$22,$EF,
$8D,$F0,$A4,$A8,$F0,$CF,$8C,$F0,$A4,$28,$CE,$8D,$F0,$A4,$2E,$FE,
$22,$78,$7F,$E4,$F6,$D8,$FD,$75,$81,$13,$02,$00,$03,$12,$FF,$0D,
$22
);

begin
    List.Items.Clear();
 

    num := DIC_Find();
    for i:=0 to num-1 do
    begin
	    hic := DIC_Open(i, nil);
		if hic >= 0 then break;		// Find the first ROCKEY
	end;
    if i = num then exit;

     	// a. Check supper password,it's required by writing process.
	for i:=0 to 7 do
        cmddata[i] := char($ff); 						// Super password is 8 FFs for demo ROCKEY
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// b. Create exe-file.
	DIC_Set(cmddata, FILL, 256, 0, nil);                			// clear buffer
	DIC_Set(cmddata, FILE_ID, BY_VALUE, $0001, nil);			// File ID
	DIC_Set(cmddata, FILE_CLASS, BY_VALUE, $ff, nil);			// File class
	DIC_Set(cmddata, FILE_ATTRIBUTE, BY_VALUE, FILEATTR_EXEC, nil);		// File attr
	DIC_Set(cmddata, FILE_SIZE, BY_VALUE, DIST_SIZE, nil);		 	// File size
	DIC_Set(cmddata, FILE_NAME, BY_ARRAY, 0, pchar('6002'));
	errcode := DIC_Command(hic, CREATE_FILE, cmddata);

	// c. Write exe-file
	DIC_Set(cmddata, WRITE_DATA, DIST_SIZE, 0, @g_progDIST);
	errcode := DIC_Command(hic, WRITE_FILE, cmddata);

	// d. return to password not verified status
	//    we cannot run program at super password verified status.
	errcode := DIC_Close(hic);
	errcode := DIC_Open(hic, nil);

	// e. Run
	a := 3;
	b := 4;
	DIC_Set(buffer, 0, 2, a, nil);			// Set a
	DIC_Set(buffer, 2, 2, b, nil); 			// Set b
	DIC_Set(cmddata, RUN_DATA, 4, $6002, buffer);	// Set data to buffer
	errcode := DIC_Command(hic, RUN, cmddata);
	DIC_Get(cmddata, RUN_DATA, BY_VALUE, buffer);	// Get data
	c := DIC_Get(buffer, 0, BY_VALUE or 2, nil);	// Get c from buffer
        ChangeByteOrder(@c,2);
	FmtStr(str,'%d*%d+%d*%d=%d', [a, a, b, b, c]);
        List.Items.Add(str);


   errcode := DIC_Close(hic);
end;

end.


