! ==========================================================================
! Demo:  Get Zone Code, Agent Code, User Code 1, and User Code 2
! Caution: no error check for the sake of briefness and understandability
! Tips:
! (1) Manage code information includes Zone code, Agent code, User code 1
!     and User code 2. Those information have been set before vendeing, user 
!     cannot modify them.  Those codes are used for management of distribution. 
!	   For developer , the manage code of all Rockey5 devices they got from agent are
!     same, Other developers cannot got Rockey5 devices with the same management code.
!	   Those information is key data to tell whether the dongle is yours.  the "Same-code dangle"
!     means dangle with same management code.
!     a) iZone: Zone code
!     b) iAgent:Agent code
!     c) iUser1:User code 1
!     d) iUser2:User code 2
! (2) The following example demonstrates another skill of DIC_Get routine. If the return mode 
!     is BY_VALUEthe last parameter can be set to NULL. You may get the parameter from the 
!     return value.
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device.
integer*4 i 
CHARACTER*256 reader_name
CHARACTER*256 cmddata 	!command buffer
CHARACTER*20  p_null
integer*2 iZone, iAgent, iUser1, iUser2;



	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		!  Stop searching once one is found.
	enddo
	if (i == num)  then
        	stop
	endif

   	errcode = DIC_Command(hic, GET_MANAGER_CODE, loc(cmddata)) 
	iZone = DIC_Get(loc(cmddata), ZONE, BY_VALUE, loc(p_null)) 
	iAgent = DIC_Get(loc(cmddata), AGENT, BY_VALUE, loc(p_null)) 
	iUser1 = DIC_Get(loc(cmddata), USER1, BY_VALUE, loc(p_null)) 
	iUser2 = DIC_Get(loc(cmddata), USER2, BY_VALUE, loc(p_null)) 
	write(*,'(" Zone code  ",z4)')  iZone 
	write(*,'(" Agent code ",z4)')  iAgent 
	write(*,'(" User code 1  ",z4)')  iUser1 
	write(*,'(" User code 2  ",z4)')  iUser2 
end

	