! ==========================================================================
! Demo: Write and run exe-file.
! Caution: no error check for the sake of briefness and understandability
! Tips:
! (1) You can write exe-files to dongle and run it in dongle. We have Integrate 
!     Design Entironment(IDE), you can write,debug,and run program there.
! (2) dist.c is dongle programwe convert the compile result to bin file, and 
!     put it to PC program via array.     
! (3) You must write exe-file to root directory after super password verification.
! (4) Demo inclue 2 steps: write and run exe-file. The first step should finished befor
!     dongle vending. Then only second step is in final product.
! ==========================================================================
! dist.c calculates a^2+b^2
!
!void main()
!{
!	unsigned int a,b,c;
!	get_input(&a,0,1,1);
!	get_input(&b,2,1,1);
!	a=a*a;
!	b=b*b;
!	c=a+b;
!	set_response(2,&c);
!	exit();
!}
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device.
integer*4 i 
integer*4 ret_code 
CHARACTER*256 reader_name
CHARACTER cmddata(256) 	
CHARACTER buffer(256) 	
CHARACTER cTmp;
CHARACTER*20  p_null
integer*2 a, b, c
integer*4,parameter :: DIST_SIZE= 193
CHARACTER g_progDIST(DIST_SIZE)
data g_progDIST /#02,#00,#b1,#75,#0e,#00,#75,#0f,#00,#75,#10,#08,#e4,#f5,#11,#75,&
#12,#01,#75,#13,#01,#12,#00,#69,#75,#0e,#00,#75,#0f,#00,#75,#10,&
#0a,#75,#11,#02,#75,#12,#01,#75,#13,#01,#12,#00,#69,#ae,#08,#af,&
#09,#ac,#08,#ad,#09,#12,#00,#9f,#8e,#08,#8f,#09,#ae,#0a,#af,#0b,&
#ac,#0a,#ad,#0b,#12,#00,#9f,#8e,#0a,#8f,#0b,#e5,#09,#25,#0b,#f5,&
#0d,#e5,#08,#35,#0a,#f5,#0c,#75,#0e,#02,#75,#0f,#00,#75,#10,#00,&
#75,#11,#0c,#12,#00,#88,#02,#00,#bd,#12,#ff,#00,#e5,#0e,#24,#00,&
#e5,#0f,#24,#01,#e5,#10,#24,#02,#e5,#11,#24,#03,#e5,#12,#24,#04,&
#e5,#13,#24,#05,#12,#ff,#0b,#22,#12,#ff,#00,#e5,#0f,#24,#00,#e5,&
#10,#24,#01,#e5,#11,#24,#02,#e5,#0e,#24,#03,#12,#ff,#0a,#22,#ef,&
#8d,#f0,#a4,#a8,#f0,#cf,#8c,#f0,#a4,#28,#ce,#8d,#f0,#a4,#2e,#fe,&
#22,#78,#7f,#e4,#f6,#d8,#fd,#75,#81,#13,#02,#00,#03,#12,#ff,#0d,&
#22/

	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	! a.Check supper password,it's required by writing process.
	do i=1 ,8
	cmddata(i)=char(255)  ! Super password is 8 FFs for demo ROCKEY
	enddo		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata)) 
	
	! b. Create exe-file.
	ret_code=DIC_Set(loc(cmddata), FILL, 256, 0, loc(p_null)) 				! clear bufferclear buffer
	ret_code=DIC_Set(loc(cmddata), FILE_ID, BY_VALUE, #0001, loc(p_null)) 			! File ID
	ret_code=DIC_Set(loc(cmddata), FILE_CLASS, BY_VALUE, #ff, loc(p_null)) 			! File class
	ret_code=DIC_Set(loc(cmddata), FILE_ATTRIBUTE, BY_VALUE, FILEATTR_EXEC, loc(p_null)) 	! File attr
	ret_code=DIC_Set(loc(cmddata), FILE_SIZE, BY_VALUE, DIST_SIZE, loc(p_null)) 		! File size
	data buffer /'6','0','0','2'/
	ret_code=DIC_Set(loc(cmddata), FILE_NAME, BY_ARRAY, 0, loc(buffer)) 
	errcode = DIC_Command(hic, CREATE_FILE, loc(cmddata)) 
	
	! c. Write exe-file
	ret_code=DIC_Set(loc(cmddata), WRITE_DATA, DIST_SIZE, 0, loc(g_progDIST) )
	errcode = DIC_Command(hic, WRITE_FILE, loc(cmddata)) 

	! d. return to password not verified status
	!    we cannot run program at super password verified status.
	errcode = DIC_Close(hic) 
	errcode = DIC_Open(hic, loc(p_null)) 

	! e. Run
	a = 3 
	b = 4 
	ret_code=DIC_Set(loc(buffer), 0, 2, a, loc(p_null)) 			! Set a
	ret_code=DIC_Set(loc(buffer), 2, 2, b, loc(p_null))  			! Set b
	ret_code=DIC_Set(loc(cmddata), RUN_DATA, 4, #6002, loc(buffer)) 	! Set data
	errcode = DIC_Command(hic, RUN, loc(cmddata)) 
	ret_code=DIC_Get(loc(cmddata), RUN_DATA, BY_VALUE, loc(buffer)) 	! Get data
	!change the data order
	cTmp=buffer(1)
	buffer(1)=buffer(2)
	buffer(2)=cTmp

	c = DIC_Get(loc(buffer), 0, IOR(BY_VALUE ,2), loc(p_null)) 		! Get c from buffer

	
	
	write(*,'(i2,"*",i1,"+",i1,"*",i1,"=",i2)') a, a, b, b, c 

	errcode=DIC_Close(hic)	
end

	