// ==========================================================================
// Get managment code
// (1) managment code help developers to manage ROCKEY. Users cannot change it.
//	a) Zone Code, ROCKEY is sold in which area
//	b) Agent Code, sold via which agent
//	c) User1 code, sold to which user
//	d) User1 code, sold to which user
// (2) Use DIC_Get to get the info
// ==========================================================================

import java.io.*;

public class Sample6
{
	public Sample6()
	{
	}

	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte []cmddata=new byte[256];	// command buffer
		int Zone, Agent, User1, User2;
		char name[]=new char[28];
		byte []tmpBuf=new byte[256];
	
		JavaRockey Rockey=new JavaRockey();
		
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, name);
			if (hic >= 0) break;		//  find the first ROCKEY
		}
		if (i == num) return;
	
		errcode = Rockey.DIC_Command(hic, Rockey.GET_MANAGER_CODE, cmddata);
		Zone = Rockey.DIC_Get(cmddata, Rockey.ZONE, Rockey.BY_VALUE, tmpBuf);
		Agent = Rockey.DIC_Get(cmddata, Rockey.AGENT, Rockey.BY_VALUE, tmpBuf);
		User1 = Rockey.DIC_Get(cmddata, Rockey.USER1, Rockey.BY_VALUE, tmpBuf);
		User2 = Rockey.DIC_Get(cmddata, Rockey.USER2, Rockey.BY_VALUE, tmpBuf);
		System.out.println("Zone code:   "+ Integer.toHexString(Zone));
		System.out.println("Agent code: "+ Integer.toHexString(Agent));
		System.out.println("User1:  "+ Integer.toHexString(User1));
		System.out.println("User2:  "+ Integer.toHexString(User2));
	
		errcode = Rockey.DIC_Close(hic);
	}

}