// ==========================================================================
// Get a Random number
// ROCKEY6 smart generates REAL random number in the smart card.
// the max. length is 16 bytes.
// to get a random number more than 16 bytes, you can consist several random 
// number together
// ==========================================================================

import java.io.*;

public class Sample7
{
	public Sample7()
	{
	}

	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte[]cmddata=new byte[256];
		char[]name=new char[20];
		byte[]tmpbuf=new byte[128];
		
		JavaRockey Rockey=new JavaRockey();
		
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, name);
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num) return;
	
		Rockey.DIC_Set(cmddata, Rockey.RANDOM_SIZE, Rockey.BY_VALUE, 16, tmpbuf);	// length of random number
		errcode = Rockey.DIC_Command(hic, Rockey.RANDOM, cmddata);	// get a random number
		for (i=0;i<16;i++) 
		{
			System.out.print(Integer.toHexString(cmddata[i]&0xff)+" ");
		}
		System.out.println("");
		errcode = Rockey.DIC_Close(hic);
	}

}