// ==========================================================================
//  Get a Random number
//  ROCKEY6 smart generates REAL random number in the smart card.
//  the max. length is 16 bytes.
//  to get a random number more than 16 bytes, you can consist several random 
//  number together
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int i, num, hic, errcode;
	char cmddata[256];

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		//  find the first ROCKEY
	}
	if (i == num) return;

	DIC_Set(cmddata, RANDOM_SIZE, BY_VALUE, 16, NULL);	// length of random number
	errcode = DIC_Command(hic, RANDOM, cmddata);	// get a random number
	for (i=0;i<16;i++) printf("%02X ", (BYTE)cmddata[i]);
	printf("\n");

	errcode = DIC_Close(hic);
}
