// ==========================================================================
// Demo: Write and run exe-file.
// Caution: no error check for the sake of briefness and understandability
// Tips:
// (1) You can write exe-files to dongle and run it in dongle. We have Integrate
//     Design Entironment(IDE), you can write,debug,and run program there.
// (2) dist.c is dongle program,we convert the compile result to bin file, and
//     put it to PC program via array.
// (3) You must write exe-file to root directory after super password verification.
// (4) Demo inclue 2 steps: write and run exe-file. The first step should finished befor
//     dongle vending. Then only second step is in final product.
// ==========================================================================
// dist.c caculate a^2+b^2
//
//void main()
//{
//	unsigned int a,b,c;
//	get_input(&a,0,1,1);
//	get_input(&b,2,1,1);
//	a=a*a;
//	b=b*b;
//	c=a+b;
//	set_response(2,&c);
//	exit();
//}

// ==========================================================================
#include <windows.h>
#include <stdio.h>
#include "dic32.h"

// convert from dist.bin
#define DIST_SIZE  193
unsigned char g_progDIST[DIST_SIZE]=
{
0x02,0x00,0xb1,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,0x08,0xe4,0xf5,0x11,0x75,
0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,
0x0a,0x75,0x11,0x02,0x75,0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0xae,0x08,0xaf,
0x09,0xac,0x08,0xad,0x09,0x12,0x00,0x9f,0x8e,0x08,0x8f,0x09,0xae,0x0a,0xaf,0x0b,
0xac,0x0a,0xad,0x0b,0x12,0x00,0x9f,0x8e,0x0a,0x8f,0x0b,0xe5,0x09,0x25,0x0b,0xf5,
0x0d,0xe5,0x08,0x35,0x0a,0xf5,0x0c,0x75,0x0e,0x02,0x75,0x0f,0x00,0x75,0x10,0x00,
0x75,0x11,0x0c,0x12,0x00,0x88,0x02,0x00,0xbd,0x12,0xff,0x00,0xe5,0x0e,0x24,0x00,
0xe5,0x0f,0x24,0x01,0xe5,0x10,0x24,0x02,0xe5,0x11,0x24,0x03,0xe5,0x12,0x24,0x04,
0xe5,0x13,0x24,0x05,0x12,0xff,0x0b,0x22,0x12,0xff,0x00,0xe5,0x0f,0x24,0x00,0xe5,
0x10,0x24,0x01,0xe5,0x11,0x24,0x02,0xe5,0x0e,0x24,0x03,0x12,0xff,0x0a,0x22,0xef,
0x8d,0xf0,0xa4,0xa8,0xf0,0xcf,0x8c,0xf0,0xa4,0x28,0xce,0x8d,0xf0,0xa4,0x2e,0xfe,
0x22,0x78,0x7f,0xe4,0xf6,0xd8,0xfd,0x75,0x81,0x13,0x02,0x00,0x03,0x12,0xff,0x0d,
0x22
};
void ReverseShort(short *Value)
{
	unsigned char *bValue=(unsigned char *)Value;
	unsigned char temp;
	temp=bValue[0];
	bValue[0]=bValue[1];
	bValue[1]=temp;
}
void main()
{
	int i, num, hic, errcode;
	char cmddata[256];	// Note: should be larger then DIST_SIZE+4
	char buffer[256];	// Note: should be large enough
	short a, b, c;

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num) return;

	// a. Check super password,it's required by writing process.
	for (i=0;i<8;i++) cmddata[i] = (char)0xff; // Super password is 8 FFs for demo ROCKEY
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// c. creat exe-file
	DIC_Set(cmddata, FILL, 256, 0, NULL);					// clear buffer
	DIC_Set(cmddata, FILE_ID, BY_VALUE, 0x0001, NULL);			// file ID
	DIC_Set(cmddata, FILE_CLASS, BY_VALUE, 0xff, NULL);			// fiel class
	DIC_Set(cmddata, FILE_ATTRIBUTE, BY_VALUE, FILEATTR_EXEC, NULL);	// file attr
	DIC_Set(cmddata, FILE_SIZE, BY_VALUE, DIST_SIZE, NULL);			// file size
	DIC_Set(cmddata, FILE_NAME, BY_ARRAY, 0, "6002");
	errcode = DIC_Command(hic, CREATE_FILE, cmddata);

	// c. Write exe-file
	DIC_Set(cmddata, WRITE_DATA, DIST_SIZE, 0, (char*)g_progDIST);
	errcode = DIC_Command(hic, WRITE_FILE, cmddata);

	// d. return to password not verified status
	//    we cannot run program at super password verified status.
	errcode = DIC_Close(hic);
	errcode = DIC_Open(hic, NULL);

	// e. Run
	a = 3;
	b = 4;
	DIC_Set(buffer, 0, 2, a, NULL);				// set a
	DIC_Set(buffer, 2, 2, b, NULL); 			// set b

	DIC_Set(cmddata, RUN_DATA, 4, 0x6002, buffer);		// set data
	errcode = DIC_Command(hic, RUN, cmddata);
	DIC_Get(cmddata, RUN_DATA, BY_VALUE, buffer);		// get data
	c = DIC_Get(buffer, 0, BY_VALUE |2, NULL);		// Get c from buffer
	// change data order 
	ReverseShort(&c);
	printf("%d*%d+%d*%d=%d\n", a, a, b, b, c);
	errcode = DIC_Close(hic);
}