// ==========================================================================
// Get free space in byte
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"


void main(int argc, char* argv[])
{
	
	int i,num, hic, errcode;
	
	printf("searching ROCKEY  ");
	num = DIC_Find();
	if (num <= 0)
	{
		printf("No ROCKEY found\n");
		return;
	}
	printf("%d\n",num);

	printf("Open ROCKEY\n");
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);	
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num)
	{
		printf("No ROCKEY found\n");
		return;
	}
	
	//get free space
	DWORD dwFreeSpace = 0;
	errcode = DIC_Command(hic, GETFREESPACE, &dwFreeSpace);
	printf("The free space is %d bytes,%d K.\n", dwFreeSpace,dwFreeSpace/1024);

	DIC_Close(hic);
	
}
