#include "sys_api.h"
#include <string.h>
#define TIMER_FILE_ID 0x6001
void main()
{
	byte currentDate[6];
    byte Date[18];
	word fileId=TIMER_FILE_ID; 
	byte Ret=0;
	int i;
	byte isValid;

	get_input(&currentDate,0,0,6);//input date
	Ret=open_file(&fileId, 0); //open file
	if(Ret)
	{
		set_response(1,&Ret);	//if an error then set a response and exit
	    exit();
	}
	Ret=read_file(0,Date,18); //read date from this file
	if(Ret)
	{
		set_response(1,&Ret);	//if an erro then set a response and exit
	    exit();
	}
	//if the time smaller than the record time then post an error
	for(i=0;i<6;i++)
	{
		if(currentDate[i]>Date[i+6])
		{
			isValid=1;
			break;
		}
		if(currentDate[i]<Date[i+6])
		{
			isValid=0;
			break;
		}
	}
	//if the time is later than the end time then post an error
	if(isValid)
	for(i=0;i<6;i++)
	{
		if(currentDate[i]<Date[i+12])
		{
			isValid=1;
			break;
		}
		if(currentDate[i]>Date[i+12])
		{
			isValid=0;
			break;
		}
	}
	if(!isValid)
	{
		Ret=255;
		set_response(1,&Ret);
		exit();
	}
	//record current time to the file
	memcpy(Date+6,currentDate,6);
	write_file(0,Date,18);
	Ret=0;
	set_response(1,&Ret);
	exit();
}
