// tutorialDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tutorial.h"
#include "tutorialDlg.h"
#include "Dic32L.h"
#include "winsock.h"
#pragma comment(lib, "Ws2_32.lib")
using namespace hbx;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "dic32.h"
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTutorialDlg dialog

CTutorialDlg::CTutorialDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTutorialDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTutorialDlg)
	m_StatusBar = _T("");
	m_InDouble = 0.0;
	m_OutDouble = 0.0;
	m_PriID = _T("");
	m_PubID = _T("");
	m_RunPubKeyID = _T("");
	m_RunPriKeyID = _T("");
	m_IsRsaEncrypt = FALSE;
	m_CreateId = _T("");
	m_CreateSize = 0;
	m_CreateType = _T("");
	m_WriteId = _T("");
	m_WriteLen = 0;
	m_WriteOffset = 0;
	m_ReadId = _T("");
	m_ReadLen = 0;
	m_ReadOffset = 0;
	m_DesId = _T("");
	m_DesKeyId = _T("");
	m_IsDesEncrypt = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTutorialDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTutorialDlg)
	DDX_Control(pDX, IDC_EDIT_RSA_DATA, m_RsaData);
	DDX_Text(pDX, IDC_STATIC_STATUSBAR, m_StatusBar);
	DDX_Text(pDX, IDC_EDIT_DOUBLE_IN, m_InDouble);
	DDX_Text(pDX, IDC_EDIT_DOUBLE_OUT, m_OutDouble);
	DDX_Text(pDX, IDC_EDIT_PRIID, m_PriID);
	DDX_Text(pDX, IDC_EDIT_PUBID, m_PubID);
	DDX_Text(pDX, IDC_EDIT1_PUBKEYID, m_RunPubKeyID);
	DDX_Text(pDX, IDC_EDIT_PRIKEYID, m_RunPriKeyID);
	DDX_Check(pDX, IDC_CHECK_RSA_ENCRYPT, m_IsRsaEncrypt);
	DDX_Text(pDX, IDC_EDIT_CREATE_ID, m_CreateId);
	DDX_Text(pDX, IDC_EDIT_CREATE_SIZE, m_CreateSize);
	DDX_Text(pDX, IDC_EDIT_CREATE_TYPE, m_CreateType);
	DDX_Text(pDX, IDC_EDIT_WRITE_ID, m_WriteId);
	DDX_Text(pDX, IDC_EDIT_WRITE_LEN, m_WriteLen);
	DDX_Text(pDX, IDC_EDIT_WRITE_OFFSET, m_WriteOffset);
	DDX_Text(pDX, IDC_EDIT_READ_ID, m_ReadId);
	DDX_Text(pDX, IDC_EDIT_READ_LEN, m_ReadLen);
	DDX_Text(pDX, IDC_EDIT_READ_OFFSET, m_ReadOffset);
	DDX_Text(pDX, IDC_EDIT_DES_ID, m_DesId);
	DDX_Text(pDX, IDC_EDIT_DES_KEY_ID, m_DesKeyId);
	DDX_Check(pDX, IDC_CHECK_DES_ENCRYPT, m_IsDesEncrypt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTutorialDlg, CDialog)
	//{{AFX_MSG_MAP(CTutorialDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTutorialDlg message handlers

BOOL CTutorialDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//unsigned char *data=new unsigned char[128];
	unsigned char data[128];
	memset(data,0,128);
	m_RsaData.SetData(data,128);
	m_RsaData.SetBPR(12);
	m_RsaData.SetFocus();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTutorialDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTutorialDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTutorialDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTutorialDlg::OnButton1() 
//Double
{
	int hic=DoOpen();
	if(hic<0)
		return;

	//add by hbx
	CFile file("c51bin\\double.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x1002,0x10,file.GetLength(),"1002",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe fil failed:%X",iRet);
	}
	//end add
	
	

	DICST_Before_Run_Data * bD=(DICST_Before_Run_Data * )new char[1024];
	DICST_After_Run_Data  *aD=(DICST_After_Run_Data * )bD;
	UpdateData();
	bD->RunID=0x1002;
	bD->ParaSize=8;
	memcpy(bD->Para,&m_InDouble,8);
	iRet=DIC_Command(hic,RUN,bD);
	if(iRet)
	{
		m_StatusBar.Format("run failed:%X",iRet);
		goto END;
	}
	memcpy(&m_OutDouble,aD->Result,aD->ResultSize);
	m_StatusBar="run successfully!";
END:
	UpdateData(FALSE);
	delete [] bD;
	DIC_Close(hic);
}

int CTutorialDlg::DoOpen()
{
	int num=DIC_Find();
	for(int i=0;i<num;i++)
	{
		int hic=DIC_Open(i,NULL);
		if(hic>=0)
			return hic;
	}
	m_StatusBar="cannot open card!";
	UpdateData(FALSE);
	return -1;
}

void CTutorialDlg::OnButton2() 
//create rsa key
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\rsaKey.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x1004,0x10,file.GetLength(),"1004",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}

	DIC_Close(hic);
	//end add
	
	unsigned char buf[4];
	WORD Len;
	WORD PriID,PubID;
	UpdateData();
	sscanf(m_PriID.GetBuffer(m_PriID.GetLength()),"%04X",&PriID);
	sscanf(m_PubID.GetBuffer(m_PubID.GetLength()),"%04X",&PubID);

	//
	PriID = htons(PriID);
	PubID = htons(PubID);
	//
	memcpy(buf,&PriID,2);
	memcpy(buf+2,&PubID,2);
	DoRun(0x1004,4,buf,&Len,buf);
}

int CTutorialDlg::DoRun(WORD ID, WORD inSize, BYTE *inBuf, WORD *outSize, BYTE *outBuf)
{
	int hic=DoOpen();
	if(hic<0)
		return hic;
	DICST_Before_Run_Data * bD=(DICST_Before_Run_Data * )new char[1024];
	DICST_After_Run_Data  *aD=(DICST_After_Run_Data * )bD;
	UpdateData();
	bD->RunID=ID;
	bD->ParaSize=inSize;
	memcpy(bD->Para,inBuf,inSize);
	int iRet=DIC_Command(hic,RUN,bD);
	if(iRet)
	{
		m_StatusBar.Format("fun failed:%X",iRet);
		goto END;
	}
	memcpy(outBuf,aD->Result,aD->ResultSize);
	*outSize=aD->ResultSize;
	m_StatusBar="run successfully!";
END:
	UpdateData(FALSE);
	delete [] bD;
	DIC_Close(hic);
	return iRet;
}

void CTutorialDlg::OnButton5() 
//RSA
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\rsa.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x2000,0x10,file.GetLength(),"2000",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}
	
	DIC_Close(hic);
	//end add
	
	UpdateData();
	WORD PriID,PubID;
	BYTE tmp;
	WORD size;
	unsigned char buf[1024]={0};
	unsigned char outBuf[128]={0};
	memset(buf,0,1024);
	memset(outBuf,0,128);
	sscanf(m_RunPriKeyID.GetBuffer(m_RunPriKeyID.GetLength()),"%04X",&PriID);
	sscanf(m_RunPubKeyID.GetBuffer(m_RunPubKeyID.GetLength()),"%04X",&PubID);

	PriID= htons(PriID);
	PubID = htons(PubID);
	if(m_IsRsaEncrypt)
	{
		memcpy(buf,&PubID,2);
		tmp=1;
		memcpy(buf+2,&tmp,1);
		m_RsaData.GetData(buf+3,128);
	}
	else
	{
		memcpy(buf,&PriID,2);
		tmp=0;
		memcpy(buf+2,&tmp,1);
		m_RsaData.GetData(buf+3,128);
	}
	iRet=DoRun(0x2000,131,buf,&size,outBuf);
	if(!iRet)
	{
		m_RsaData.SetData(outBuf,128);
	}
	UpdateData(false);
}

void CTutorialDlg::OnOK() 
{
	
	CDialog::OnOK();
}

void CTutorialDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	
}

void CTutorialDlg::OnButton6()
//create file 
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\createFile.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x2002,0x10,file.GetLength(),"2002",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}
	
	DIC_Close(hic);
	//end add

	WORD FileID;
	BYTE FileType;
	unsigned char buf[12];
	unsigned char outBuf[12];
	WORD outSize;
	UpdateData();
	sscanf(m_CreateId.GetBuffer(m_CreateId.GetLength()),"%04X",&FileID);
	sscanf(m_CreateType.GetBuffer(m_CreateType.GetLength()),"%02X",&FileType);

	FileID=htons(FileID);
	m_CreateSize=htons(m_CreateSize);
	
	memcpy(buf,&FileID,2);
	memcpy(buf+2,&FileType,1);
	memcpy(buf+4,&m_CreateSize,2);
	DoRun(0x2002,6,buf,&outSize,outBuf);
}

void CTutorialDlg::OnButton3()
//write file 
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\writeFile.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x1006,0x10,file.GetLength(),"1006",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}
	
	DIC_Close(hic);
	//end add

	WORD FileID,outSize;
	unsigned char buf[140];
	unsigned char outBuf[12];
	UpdateData();
	sscanf(m_WriteId.GetBuffer(m_WriteId.GetLength()),"%04X",&FileID);

	FileID=htons(FileID);
	m_WriteOffset=htons(m_WriteOffset);
	m_WriteLen=htons(m_WriteLen);
	
	memcpy(buf,&FileID,2);
	memcpy(buf+2,&m_WriteOffset,2);
	memcpy(buf+4,&m_WriteLen,2);

	int len= m_WriteLen>128?128:m_WriteLen;
	m_RsaData.GetData(buf+6,len);

	
	DoRun(0x1006,len+6,buf,&outSize,outBuf);
}

void CTutorialDlg::OnButton7()
//read file
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\readFile.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x2004,0x10,file.GetLength(),"2004",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}
	
	DIC_Close(hic);
	//end add
	WORD FileID,outSize;
	unsigned char buf[12];
	unsigned char outBuf[128];
	UpdateData();
	sscanf(m_ReadId.GetBuffer(m_ReadId.GetLength()),"%04X",&FileID);

	//
	m_ReadLen = m_ReadLen > 128 ? 128 :m_ReadLen;
	FileID=htons(FileID);
	m_ReadOffset=htons(m_ReadOffset);
	m_ReadLen=htons(m_ReadLen);

	
	//
	memcpy(buf,&FileID,2);
	memcpy(buf+2,&m_ReadOffset,2);
	memcpy(buf+4,&m_ReadLen,2);

	ZeroMemory(outBuf, 128);
	iRet=DoRun(0x2004,6,buf,&outSize,outBuf);
	if(!iRet)
	{
		
		
		m_RsaData.SetData(outBuf,128);
	}
}

void CTutorialDlg::OnButton4()
//DES 
{
	int hic=DoOpen();
	if(hic<0)
		return;
	
	//add by hbx
	CFile file("c51bin\\des.bin",CFile::modeRead);
	byte fileBuf[2000]={0};
	file.Read(fileBuf,file.GetLength());
	
	int iRet = D32_CreateFile(hic,0x1008,0x10,file.GetLength(),"1008",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create exe file failed:%X",iRet);
	}
	
	memcpy(fileBuf, "\x01\x08\x46\x56\x74\x68\xf6\x47\x67\x98", 8);
	iRet = D32_CreateFile(hic,0x0003,0x00,10,"des",fileBuf);
	if(0 != iRet){
		m_StatusBar.Format("create DES key file failed:%X",iRet);
	}

	DIC_Close(hic);
	//end add
	UpdateData();
	WORD fileID;
	BYTE tmp,KeyId;
	WORD size;
	unsigned char buf[1024];
	unsigned char outBuf[128];
	memset(buf,0,1024);
	memset(outBuf,0,128);
	sscanf(m_DesId.GetBuffer(m_DesId.GetLength()),"%04X",&fileID);
	sscanf(m_DesKeyId.GetBuffer(m_DesKeyId.GetLength()),"%02X",&KeyId);

	fileID= htons(fileID);
	
	memcpy(buf,&fileID,2);
	memcpy(buf+2,&KeyId,1);
	if(m_IsDesEncrypt)
	{
		tmp=1;
		memcpy(buf+3,&tmp,1);
		m_RsaData.GetData(buf+4,128);
	}
	else
	{

		tmp=0;
		memcpy(buf+3,&tmp,1);
		m_RsaData.GetData(buf+4,128);
	}
	iRet=DoRun(0x1008,132,buf,&size,outBuf);
	if(!iRet)
	{
		m_RsaData.SetData(outBuf,128);
	}
	UpdateData(false);
}
